VERSION 5.00
Begin VB.Form frmHavingABall 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Solar System Explorer"
   ClientHeight    =   4110
   ClientLeft      =   4815
   ClientTop       =   4860
   ClientWidth     =   10140
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4110
   ScaleWidth      =   10140
   Begin VB.Frame fraCam 
      Caption         =   "Camera"
      Height          =   1335
      Left            =   6360
      TabIndex        =   16
      Top             =   120
      Width           =   2655
      Begin VB.Label lblCamRoll 
         Caption         =   "Roll"
         Height          =   255
         Left            =   1200
         TabIndex        =   22
         Top             =   960
         Width           =   1215
      End
      Begin VB.Label lblCamPitch 
         Caption         =   "Pitch"
         Height          =   255
         Left            =   1200
         TabIndex        =   21
         Top             =   600
         Width           =   1215
      End
      Begin VB.Label lblCamYaw 
         Caption         =   "Yaw"
         Height          =   255
         Left            =   1200
         TabIndex        =   20
         Top             =   240
         Width           =   1215
      End
      Begin VB.Label lblCamZ 
         Caption         =   "Z"
         Height          =   255
         Left            =   120
         TabIndex        =   19
         Top             =   960
         Width           =   975
      End
      Begin VB.Label lblCamY 
         Caption         =   "Y"
         Height          =   255
         Left            =   120
         TabIndex        =   18
         Top             =   600
         Width           =   975
      End
      Begin VB.Label lblCamX 
         Caption         =   "X"
         Height          =   255
         Left            =   120
         TabIndex        =   17
         Top             =   240
         Width           =   975
      End
   End
   Begin VB.CheckBox chkDrawStars 
      Caption         =   "Draw Stars"
      Height          =   255
      Left            =   4800
      TabIndex        =   15
      Top             =   120
      Width           =   1575
   End
   Begin VB.Frame fraVisit 
      Caption         =   "Visit a planet"
      Height          =   2415
      Left            =   4560
      TabIndex        =   4
      Top             =   1560
      Width           =   2895
      Begin VB.OptionButton optPlanet 
         Caption         =   "Pluto"
         Height          =   255
         Index           =   9
         Left            =   1800
         TabIndex        =   14
         Top             =   1920
         Width           =   975
      End
      Begin VB.OptionButton optPlanet 
         Caption         =   "Neptune"
         Height          =   255
         Index           =   8
         Left            =   1800
         TabIndex        =   13
         Top             =   1530
         Width           =   975
      End
      Begin VB.OptionButton optPlanet 
         Caption         =   "Uranus"
         Height          =   255
         Index           =   7
         Left            =   1800
         TabIndex        =   12
         Top             =   1140
         Width           =   975
      End
      Begin VB.OptionButton optPlanet 
         Caption         =   "Saturn"
         Height          =   255
         Index           =   6
         Left            =   1800
         TabIndex        =   11
         Top             =   750
         Width           =   975
      End
      Begin VB.OptionButton optPlanet 
         Caption         =   "Jupiter"
         Height          =   255
         Index           =   5
         Left            =   1800
         TabIndex        =   10
         Top             =   360
         Width           =   975
      End
      Begin VB.OptionButton optPlanet 
         Caption         =   "Mars"
         Height          =   255
         Index           =   4
         Left            =   240
         TabIndex        =   9
         Top             =   1920
         Width           =   1095
      End
      Begin VB.OptionButton optPlanet 
         Caption         =   "Earth"
         Height          =   255
         Index           =   3
         Left            =   240
         TabIndex        =   8
         Top             =   1530
         Width           =   1095
      End
      Begin VB.OptionButton optPlanet 
         Caption         =   "Venus"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   7
         Top             =   1140
         Width           =   1095
      End
      Begin VB.OptionButton optPlanet 
         Caption         =   "Mercury"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   6
         Top             =   750
         Width           =   1095
      End
      Begin VB.OptionButton optPlanet 
         Caption         =   "Free Flight"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   5
         Top             =   360
         Width           =   1095
      End
   End
   Begin VB.CheckBox chkLights 
      Caption         =   "Lights"
      Height          =   255
      Left            =   4800
      TabIndex        =   2
      Top             =   600
      Width           =   1335
   End
   Begin VB.CheckBox chkSmoothShading 
      Caption         =   "Smooth Shading"
      Height          =   255
      Left            =   4800
      TabIndex        =   1
      Top             =   360
      Width           =   1575
   End
   Begin VB.Timer tmrRender 
      Interval        =   10
      Left            =   7440
      Top             =   2760
   End
   Begin VB.PictureBox picDisplayArea 
      Height          =   3855
      Left            =   0
      ScaleHeight     =   3795
      ScaleWidth      =   4395
      TabIndex        =   0
      Top             =   120
      Width           =   4455
   End
   Begin VB.Label lblStatus 
      Height          =   495
      Left            =   4800
      TabIndex        =   3
      Top             =   960
      Width           =   1455
   End
End
Attribute VB_Name = "frmHavingABall"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Solar System Explorer by Mike Brascome
'
'More samples of using VB with DirectX are at http://collective.freeservers.com/visbasic.htm
'
Private Const ParticleSize As Single = 1
Private Const PI = 3.14159265
Private Const Rad = PI / 180              'multiply degrees by Rad to get angle in radians
' DirectDraw variables.
Private m_dx8 As DirectX8
Private m_d3d As Direct3D8
Private m_d3dDevice As Direct3DDevice8

' Object variables.
Private m_VertexBuffer As Direct3DVertexBuffer8

' Custom vertex structure.
Private Type CUSTOMVERTEX
    Position As D3DVECTOR
    Normal As D3DVECTOR
    tu As Single
    tv As Single
End Type
Private m_VertexSize As Long

Private Type LUNAR
    Position As D3DVECTOR
    yaw As Single
    roll As Single
    pitch As Single
    xScale As Single
    yScale As Single
    zScale As Single
    Texture As Direct3DTexture8
    dFromPlanet As Single
    AngFromPlanet As Single
    GeomStart As Long
    GeomLen As Long
    GeomType As Integer
    ViewDist As Single
    ViewAngle As Single
End Type

Private Type WORLD
    Position As D3DVECTOR
    yaw As Single
    roll As Single
    pitch As Single
    xScale As Single
    yScale As Single
    zScale As Single
    Texture As Direct3DTexture8
    dFromSun As Single
    AngFromSun As Single
    GeomStart As Long
    GeomLen As Long
    GeomType As Integer
    ViewDist As Single
    ViewAngle As Single
    Moons As Integer
    ArMoon() As LUNAR
    Rings As Integer
    RingGeomStart As Long
    RingGeomLen As Long
    RingGeomType As Integer
    RingTexture As Direct3DTexture8
    RingScale As Single
    RingPitch As Single
End Type
' Custom vertex definition.
Private Const VERTEX_TYPE = (D3DFVF_XYZ Or D3DFVF_NORMAL Or D3DFVF_TEX1)

Dim planets() As WORLD

' Rotation parameters.
Private m_Theta As Single
Private m_DTheta As Single

' Materials.
Private m_FloorMaterial As D3DMATERIAL8
Private m_SphereMaterial As D3DMATERIAL8

' Sphere parameters.
Private Const SPHERE_RADIUS = 6
Private Const NUM_PHI = 5
Private Const DPHI = PI / NUM_PHI
Private Const NUM_THETA = 2 * NUM_PHI
Private Const DTHETA = 2 * PI / NUM_THETA

Private m_FirstRingVertex As Long
Private m_FirstCapVertex As Long

'New stuff
Dim D3DX As D3DX8 '//A helper library
Dim Texture As Direct3DTexture8
Dim TransTexture As Direct3DTexture8 '//This texture will have transparency information encoded into it....

Dim SphereTest() As CUSTOMVERTEX
Dim NumSphereVer As Long

'User Interface
Dim KeyUp As Boolean                  'Used to check for key presses
Dim KeyRight As Boolean               'True if key is pressed, false if its not
Dim KeyDown As Boolean
Dim KeyLeft As Boolean
Dim Yup As Boolean
Dim Ydown As Boolean
Dim bSpace As Boolean
Dim bReverse As Boolean

Dim CamPos As D3DVECTOR
Dim CamYaw As Single
Dim CamRoll As Single
Dim CamPitch As Single

Dim intVisitPlanet As Integer

Private Declare Function GetTickCount Lib "kernel32" () As Long



Private Sub chkLights_Click()
    If Me.chkLights.Value = vbChecked Then
        m_d3dDevice.SetRenderState D3DRS_LIGHTING, True
    Else
        m_d3dDevice.SetRenderState D3DRS_LIGHTING, False
    End If
    Me.picDisplayArea.SetFocus
End Sub

' Enable or disable smooth shading.
Private Sub chkSmoothShading_Click()
    If Me.chkSmoothShading.Value = vbChecked Then
        m_d3dDevice.SetRenderState D3DRS_SHADEMODE, D3DSHADE_GOURAUD
    Else
        m_d3dDevice.SetRenderState D3DRS_SHADEMODE, D3DSHADE_FLAT
    End If
    Me.picDisplayArea.SetFocus
End Sub

Private Sub Form_Activate()
    Me.optPlanet(0).Value = True
    Me.picDisplayArea.SetFocus
End Sub




Private Sub optPlanet_Click(Index As Integer)
    intVisitPlanet = Index
    If Index = 0 Then
        Me.picDisplayArea.SetFocus
    End If
End Sub

' Render the scene.
Private Sub tmrRender_Timer()
    RenderObjects
End Sub
' Add a vertex to the vertex list.
Private Sub AddVertex(ByRef num_vertices As Long, vertices() As CUSTOMVERTEX, _
    ByVal x As Single, ByVal y As Single, ByVal z As Single, _
    ByVal nx As Single, ByVal ny As Single, ByVal nz As Single)

    num_vertices = num_vertices + 1
    ReDim Preserve vertices(0 To num_vertices - 1)

    With vertices(num_vertices - 1)
        .Position = MakeD3DVector(x, y, z)
        .Normal = MakeD3DVector(nx, ny, nz)
    End With
End Sub
' Add a triangle's vertices to the vertex list.
Private Sub AddTriangleWithNormal(ByRef num_vertices As Long, vertices() As CUSTOMVERTEX, _
    ByVal x1 As Single, ByVal y1 As Single, ByVal z1 As Single, _
    ByVal x2 As Single, ByVal y2 As Single, ByVal z2 As Single, _
    ByVal X3 As Single, ByVal Y3 As Single, ByVal Z3 As Single)
Dim n As D3DVECTOR

    ' Calculate the cross product of the triangle's first two sides.
    D3DXVec3Cross n, _
        MakeD3DVector(x2 - x1, y2 - y1, z2 - z1), _
        MakeD3DVector(X3 - x2, Y3 - y2, Z3 - z2)

    ' Make the vertices.
    AddVertex num_vertices, vertices, x1, y1, z1, n.x, n.y, n.z
    AddVertex num_vertices, vertices, x2, y2, z2, n.x, n.y, n.z
    AddVertex num_vertices, vertices, X3, Y3, Z3, n.x, n.y, n.z
End Sub
' Create light objects.
Private Sub InitializeLights()
Dim light As D3DLIGHT8

    ' Create a white directional light.
    With light
        .Position.x = 0
        .Position.y = 0
        .Position.z = 0
        .Type = D3DLIGHT_POINT
        .diffuse = MakeD3DColor(1, 1, 1, 1#)
       ' .Direction = MakeD3DVector(0, 1, 0)
        .Range = 2000#
        .Attenuation0 = 1
'        .Attenuation1 = 1
'        .Attenuation2 = 1
    End With

    ' Set this as light 0.
    m_d3dDevice.SetLight 0, light

    ' Turn on light 0.
    m_d3dDevice.LightEnable 0, True

    ' Make sure lighting is enabled.
    'm_d3dDevice.SetRenderState D3DRS_LIGHTING, True
    m_d3dDevice.SetRenderState D3DRS_LIGHTING, False

    ' Make some ambient light.
    m_d3dDevice.SetRenderState D3DRS_AMBIENT, D3DColorMake(0.3, 0.3, 0.3, 1#)
End Sub

' Initalize the objects we will display.
Private Sub InitializeObjects()
Dim num_vertices As Long
Dim tmpVertices() As CUSTOMVERTEX
Dim tmpNumVertices As Long
Dim tmpRing() As CUSTOMVERTEX
Dim TotalVert As Long
Dim tmpRingVerts As Long
Dim p As Integer
Dim m As Integer

    
    'Use for planets
    GenerateEllipse SphereTest, 10, 10, 1, 1, 1, NumSphereVer, False, False, 1
    'Use for space environment map
    GenerateEllipse tmpVertices, 15, 15, 1, 1, 1, tmpNumVertices, False, True, 12
    'Use for rings
    GenerateRing tmpRing, 25, tmpRingVerts, 1
    
    ReDim planets(0 To 10)
    For p = 0 To 10
        planets(p).pitch = 0
        planets(p).roll = 0
        planets(p).yaw = 0
        planets(p).xScale = 1
        planets(p).yScale = 1
        planets(p).zScale = 1
        planets(p).Position.x = 0
        planets(p).Position.z = ((p Mod 3) * 3) - 3
        If p = 0 Then
            planets(p).Position.x = 0
            planets(p).Position.y = 0
            planets(p).Position.z = 0
        End If
        planets(p).Position.y = 0
        planets(p).AngFromSun = 360 * Rnd
        planets(p).GeomStart = 0
        planets(p).GeomLen = NumSphereVer
        planets(p).GeomType = D3DPT_TRIANGLESTRIP
        planets(p).ViewAngle = -10
        planets(p).ViewDist = 3
        planets(p).Moons = 0
        planets(p).Rings = 0
        planets(6).RingGeomType = D3DPT_TRIANGLESTRIP
    Next
    
    Set planets(0).Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\SunMap.bmp")
    planets(0).dFromSun = 0
    planets(0).xScale = 15
    planets(0).yScale = 15
    planets(0).zScale = 15
'    planets(0).GeomStart = 220
'    planets(0).GeomLen = 440
        
    Set planets(1).Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\MercuryMap.bmp")
    planets(1).dFromSun = 0.5
    planets(1).xScale = 0.7
    planets(1).yScale = 0.7
    planets(1).zScale = 0.7
    
    Set planets(2).Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\VenusMap.bmp")
    planets(2).dFromSun = 0.75
    planets(2).xScale = 1
    planets(2).yScale = 1
    planets(2).zScale = 1
    
    Set planets(3).Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\EarthMap.bmp")
    planets(3).dFromSun = 1
    planets(3).xScale = 1
    planets(3).yScale = 1
    planets(3).zScale = 1
    planets(3).ViewAngle = -5
    planets(3).ViewDist = 1
    planets(3).Moons = 1
    
    
    Set planets(4).Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\MarsMap.bmp")
    planets(4).dFromSun = 1.2
    planets(4).xScale = 0.6
    planets(4).yScale = 0.6
    planets(4).zScale = 0.6
    planets(4).ViewAngle = 3
    planets(4).ViewDist = 1
    planets(4).Moons = 2
    
    
    Set planets(5).Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\JupiterMap.bmp")
    planets(5).dFromSun = 5
    planets(5).xScale = 9
    planets(5).yScale = 9
    planets(5).zScale = 9
    planets(5).ViewAngle = 3
    planets(5).ViewDist = 20
    planets(5).Moons = 20
    planets(5).Rings = 1
    planets(5).RingGeomStart = NumSphereVer + tmpNumVertices
    planets(5).RingGeomLen = tmpRingVerts
    planets(5).RingPitch = 5
    planets(5).RingScale = 11
    Set planets(5).RingTexture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\RingMap.bmp")
    
    
    Set planets(6).Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\SaturnMap.bmp")
    planets(6).dFromSun = 9
    planets(6).xScale = 5
    planets(6).yScale = 5
    planets(6).zScale = 5
    planets(6).ViewAngle = 1
    planets(6).ViewDist = 20
    planets(6).Moons = 30
    planets(6).Rings = 1
    planets(6).RingGeomStart = NumSphereVer + tmpNumVertices
    planets(6).RingGeomLen = tmpRingVerts
    planets(6).RingPitch = 5
    planets(6).RingScale = 6
    Set planets(6).RingTexture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\RingMap.bmp")
    
    Set planets(7).Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\UranusMap.bmp")
    planets(7).dFromSun = 21
    planets(7).xScale = 3
    planets(7).yScale = 3
    planets(7).zScale = 3
    planets(7).ViewAngle = 0.5
    planets(7).ViewDist = 20
    planets(7).Moons = 20
    planets(7).Rings = 1
    planets(7).RingGeomStart = NumSphereVer + tmpNumVertices
    planets(7).RingGeomLen = tmpRingVerts
    planets(7).RingPitch = 85
    planets(7).RingScale = 6
    planets(7).roll = 85
    Set planets(7).RingTexture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\RingMap.bmp")
    
    
    Set planets(8).Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\NeptuneMap.bmp")
    planets(8).dFromSun = 30
    planets(8).xScale = 3
    planets(8).yScale = 3
    planets(8).zScale = 3
    planets(8).ViewAngle = 0.2
    planets(8).ViewDist = 20
    planets(8).Moons = 6

    
    Set planets(9).Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\PlutoMap.bmp")
    planets(9).dFromSun = 39
    planets(9).xScale = 0.5
    planets(9).yScale = 0.5
    planets(9).zScale = 0.5
    planets(9).ViewAngle = -0.1
    planets(9).ViewDist = 5
    planets(9).Moons = 1
        
    Set planets(10).Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\space.bmp")
    planets(10).dFromSun = 0
    planets(10).xScale = 2000
    planets(10).yScale = 2000
    planets(10).zScale = 2000
    planets(10).GeomStart = NumSphereVer
    planets(10).GeomLen = tmpNumVertices - 2
    'planets(10).GeomType = D3DPT_POINTLIST
    
    For p = 1 To 9
        If planets(p).Moons > 0 Then
            ReDim planets(p).ArMoon(planets(p).Moons)
            For m = 1 To planets(p).Moons
                With planets(p).ArMoon(m)
                    .AngFromPlanet = 360 * Rnd
                    .dFromPlanet = planets(p).xScale * 1.2 + m * 2
                    .xScale = 0.25
                    .yScale = 0.25
                    .zScale = 0.25
                    .GeomStart = 0
                    .GeomLen = NumSphereVer
                    .GeomType = D3DPT_TRIANGLESTRIP
                    Set .Texture = D3DX.CreateTextureFromFile(m_d3dDevice, App.Path & "\MoonMap.bmp")
                End With
            Next
        End If
                
    Next
    
    TotalVert = NumSphereVer + tmpNumVertices
    'Add the inverted sphere to the array
    ReDim Preserve SphereTest(TotalVert)
    For p = NumSphereVer To TotalVert
        SphereTest(p) = tmpVertices(p - NumSphereVer)
    Next
    
    TotalVert = TotalVert + tmpRingVerts
    'Add the ring to the array
    ReDim Preserve SphereTest(TotalVert)
    For p = TotalVert - tmpRingVerts To TotalVert
        SphereTest(p) = tmpRing(p - (TotalVert - tmpRingVerts))
    Next
    
    m_VertexSize = Len(SphereTest(0))
    ' Create the vertex buffer.
    Set m_VertexBuffer = m_d3dDevice.CreateVertexBuffer(TotalVert * m_VertexSize, 0, VERTEX_TYPE, D3DPOOL_DEFAULT)
    ' Fill the vertex buffer.
    D3DVertexBuffer8SetData m_VertexBuffer, 0, TotalVert * m_VertexSize, 0, SphereTest(0)

    ' Set the vertex stream source.
    m_d3dDevice.SetStreamSource 0, m_VertexBuffer, m_VertexSize
    m_d3dDevice.SetVertexShader VERTEX_TYPE

    ' Create the materials using diffuse and ambient light.
    With m_FloorMaterial
        .diffuse = MakeD3DColor(0#, 0.5, 1#, 1#)
        .Ambient = .diffuse
    End With
    With m_SphereMaterial
        .diffuse = MakeD3DColor(1#, 1#, 1#, 1#)
        .Ambient = .diffuse
    End With

    ' Create the materials using diffuse and ambient light.
    With m_FloorMaterial
        .diffuse = MakeD3DColor(0#, 0.5, 1#, 1#)
        .Ambient = .diffuse
    End With
    With m_SphereMaterial
        .diffuse = MakeD3DColor(1#, 1#, 1#, 1#)
        .Ambient = .diffuse
    End With

End Sub

Private Sub GenerateEllipse(pV() As CUSTOMVERTEX, NumRings As Long, NumSegments As Long, fXScale As Single, fZScale As Single, fYScale As Single, NumVertices As Long, Optional bBend As Boolean = False, Optional bInside As Boolean = False, Optional TexScale As Single = 1#)
    Dim fDeltaRingAngle As Single
    Dim fDeltaSegAngle As Single
    Dim ppVert As Long
    Dim Ring As Long
    Dim Seg As Long
    Dim r0 As Single
    Dim x0 As Single
    Dim y0 As Single
    Dim z0 As Single
    Dim r1 As Single
    Dim x1 As Single
    Dim y1 As Single
    Dim z1 As Single
    Dim v1 As D3DVECTOR
    Dim v2 As D3DVECTOR
    
    '// Allocate space for the sphere
    ReDim pV(2 * NumRings * (NumSegments + 1))
    NumVertices = 2 * NumRings * (NumSegments + 1)

    '// Establish constants used in sphere generation
    fDeltaRingAngle = PI / NumRings
    fDeltaSegAngle = 2 * PI / NumSegments
    '// Generate the group of rings for the sphere
    For Ring = IIf(bInside, NumRings - 1, 0) To IIf(bInside, 0, NumRings - 1) Step IIf(bInside, -1, 1)
        r0 = Sin(Ring * fDeltaRingAngle)
        r1 = Sin((Ring + 1) * fDeltaRingAngle)
        y0 = Cos(Ring * fDeltaRingAngle)
        y1 = Cos((Ring + 1) * fDeltaRingAngle)

        '// Generate the group of segments for the current ring
        For Seg = IIf(bInside, NumSegments, 0) To IIf(bInside, 0, NumSegments) Step IIf(bInside, -1, 1)
            x0 = r0 * Sin(Seg * fDeltaSegAngle)
            z0 = r0 * Cos(Seg * fDeltaSegAngle)
            x1 = r1 * Sin(Seg * fDeltaSegAngle)
            z1 = r1 * Cos(Seg * fDeltaSegAngle)
            
            If bBend Then
                ' bend slightly :-)
                x0 = x0 + (y0 * y0 * 2)
                x1 = x1 + (y1 * y1 * 2)
            End If
            
            ' Add two vertices to the strip which makes up the sphere
            'If Not bInside Then
                v1 = vD3DVector(fXScale * x0, fYScale * y0, fZScale * z0)
                v2 = vD3DVector(x0, y0, z0)
                pV(ppVert) = vD3DVertex(v1, v2, -Seg / NumSegments * TexScale, Ring / NumRings * TexScale, bInside)
                ppVert = ppVert + 1
            'End If
            
            v1 = vD3DVector(fXScale * x1, fYScale * y1, fZScale * z1)
            v2 = vD3DVector(x1, y1, z1)
            pV(ppVert) = vD3DVertex(v1, v2, -Seg / NumSegments * TexScale, (Ring + 1) / NumRings * TexScale, bInside)
            ppVert = ppVert + 1
            
        Next
    Next

End Sub
Private Function vD3DVertex(p1 As D3DVECTOR, vNorm As D3DVECTOR, tu As Single, tv As Single, bInside As Boolean) As CUSTOMVERTEX
    With vD3DVertex
        .Position.x = p1.x
        .Position.y = p1.y
        .Position.z = p1.z
        If bInside = False Then
            .Normal.x = vNorm.x
            .Normal.y = vNorm.y
            .Normal.z = vNorm.z
        Else
            .Normal.x = -vNorm.x
            .Normal.y = -vNorm.y
            .Normal.z = -vNorm.z
        End If
        .tu = tu
        .tv = tv
    End With
End Function

Private Sub GenerateRing(pV() As CUSTOMVERTEX, NumSegments As Long, NumVertices As Long, Optional TexScale As Single = 1#)
    Dim fDeltaRingAngle As Single
    Dim fDeltaSegAngle As Single
    Dim ppVert As Long
    Dim Ring As Long
    Dim Seg As Long
    Dim r0 As Single
    Dim x0 As Single
    Dim y0 As Single
    Dim z0 As Single
    Dim r1 As Single
    Dim x1 As Single
    Dim y1 As Single
    Dim z1 As Single
    Dim v1 As D3DVECTOR
    Dim v2 As D3DVECTOR
    Dim bInside As Boolean
    
    '// Allocate space for the sphere
    ReDim pV(4 * (NumSegments + 1))
    NumVertices = 4 * (NumSegments + 1)
    r0 = 1
    r1 = 2
    y0 = -0.001
    bInside = False
    '// Establish constants used in ring generation
    fDeltaSegAngle = 2 * PI / NumSegments
    
    '// Generate the group of segments for the current ring
    For Seg = 0 To NumSegments
        x0 = r0 * Sin(Seg * fDeltaSegAngle)
        z0 = r0 * Cos(Seg * fDeltaSegAngle)
        x1 = r1 * Sin(Seg * fDeltaSegAngle)
        z1 = r1 * Cos(Seg * fDeltaSegAngle)
                    
        v1 = vD3DVector(x0, y0, z0)
        pV(ppVert) = vD3DVertex(v1, vD3DVector(0, 1, 0), Seg / NumSegments * TexScale, 0, bInside)
        ppVert = ppVert + 1
        
        v1 = vD3DVector(x1, y0, z1)
        pV(ppVert) = vD3DVertex(v1, vD3DVector(0, 1, 0), Seg / NumSegments * TexScale, 1, bInside)
        ppVert = ppVert + 1
    Next
    bInside = True
    y0 = 0.001
    For Seg = NumSegments To 0 Step -1
        x0 = r0 * Sin(Seg * fDeltaSegAngle)
        z0 = r0 * Cos(Seg * fDeltaSegAngle)
        x1 = r1 * Sin(Seg * fDeltaSegAngle)
        z1 = r1 * Cos(Seg * fDeltaSegAngle)
                    
        v1 = vD3DVector(x0, y0, z0)
        pV(ppVert) = vD3DVertex(v1, vD3DVector(0, -1, 0), -Seg / NumSegments * TexScale, 0, bInside)
        ppVert = ppVert + 1
        
        v1 = vD3DVector(x1, y0, z1)
        pV(ppVert) = vD3DVertex(v1, vD3DVector(0, -1, 0), -Seg / NumSegments * TexScale, 1, bInside)
        ppVert = ppVert + 1
    Next


End Sub
Public Function vD3DVector(x As Single, y As Single, z As Single) As D3DVECTOR
    With vD3DVector
        .x = x
        .y = y
        .z = z
    End With
End Function

' Define the viewing position.
Private Sub InitializeScene()
Dim view_matrix As D3DMATRIX
Dim projection_matrix As D3DMATRIX

    ' Define lights.
    InitializeLights

    CamPos.x = 100
    CamPos.y = 0
    CamPos.z = 0

'   Start out close to Uranus
'    CamPos.x = -800
'    CamPos.y = 0
'    CamPos.z = 0

    CamYaw = PI
    ' Define the viewing position.
    D3DXMatrixLookAtLH view_matrix, _
        MakeD3DVector(20, 0, 0), _
        MakeD3DVector(0#, 0#, 0#), _
        MakeD3DVector(0#, 1#, 0#)
    m_d3dDevice.SetTransform D3DTS_VIEW, view_matrix

    ' Define the projection matrix.
    D3DXMatrixPerspectiveFovLH projection_matrix, PI / 4, _
        picDisplayArea.ScaleHeight / picDisplayArea.ScaleWidth, _
        1, 4000
    m_d3dDevice.SetTransform D3DTS_PROJECTION, projection_matrix

    ' Disable z-buffering.
    m_d3dDevice.SetRenderState D3DRS_ZENABLE, D3DZB_TRUE

    ' Enable culling.
    m_d3dDevice.SetRenderState D3DRS_CULLMODE, D3DCULL_CCW

    ' Use flat shading.
    m_d3dDevice.SetRenderState D3DRS_SHADEMODE, D3DSHADE_FLAT

    ' Define the rotation parameters.
    m_Theta = 0
    m_DTheta = PI / 20
End Sub
' Initialize a D3DCOLORVALUE.
Private Function MakeD3DColor(ByVal r As Single, ByVal g As Single, ByVal b As Single, ByVal a As Single) As D3DCOLORVALUE
    MakeD3DColor.r = r
    MakeD3DColor.g = g
    MakeD3DColor.b = b
    MakeD3DColor.a = a
End Function

' Return a vector.
Function MakeD3DVector(ByVal x As Single, ByVal y As Single, ByVal z As Single) As D3DVECTOR
    MakeD3DVector.x = x
    MakeD3DVector.y = y
    MakeD3DVector.z = z
End Function

Private Sub Form_Load()
    ' Initialize DirectX and Direct3D.
    InitializeDirect3D picDisplayArea.hWnd

    ' Initialize the object data structures.
    InitializeObjects

    ' Initialize static scene variables (transformations, lights, etc.).
    InitializeScene
    
End Sub

' Free Direct3D resources.
Private Sub Form_Unload(Cancel As Integer)
    Cleanup
End Sub

' Initialize DirectX and Direct3D.
Private Sub InitializeDirect3D(ByVal focus_hWnd As Long)
Dim display_mode As D3DDISPLAYMODE
Dim present_parameters As D3DPRESENT_PARAMETERS

    On Error Resume Next

    ' Create the DirectX object.
    Set m_dx8 = New DirectX8
    Set D3DX = New D3DX8 '//Create our helper library...

    ' Create the Direct3D object.
    Set m_d3d = m_dx8.Direct3DCreate()
    If m_d3d Is Nothing Then
        MsgBox "Error creating Direct3D object"
        Unload Me
        Exit Sub
    End If

    ' Get display mode iformation.
    m_d3d.GetAdapterDisplayMode D3DADAPTER_DEFAULT, display_mode

    ' Define the parameters of the Direct3D device. Most default
    ' to zero. We set Windows to 1 because the application runs
    ' in a window. SwapEffect = D3DSWAPEFFECT_COPY_VSYNC prevents
    ' image tearing.
    With present_parameters
        .Windowed = 1
        .SwapEffect = D3DSWAPEFFECT_COPY_VSYNC
        .BackBufferFormat = display_mode.Format
        .BackBufferCount = 1
        .EnableAutoDepthStencil = 1
        .AutoDepthStencilFormat = D3DFMT_D16
    End With

    ' Create the Direct3D device. Try for a HAL device. If that
    ' fails, try using the reference rasterizer.
    '
    ' We specify software vertex processing because it should
    ' work on all systems. Hardware processing would be faster
    ' if available.
    Set m_d3dDevice = m_d3d.CreateDevice( _
        D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, focus_hWnd, _
        D3DCREATE_SOFTWARE_VERTEXPROCESSING, present_parameters)

    If m_d3dDevice Is Nothing Then
        ' HAL unavailable. Try the reference rasterizer.
        Set m_d3dDevice = m_d3d.CreateDevice( _
            D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, focus_hWnd, _
            D3DCREATE_SOFTWARE_VERTEXPROCESSING, present_parameters)
    End If

    If m_d3dDevice Is Nothing Then
        ' Could not find any usable device.
        MsgBox "Error creating Direct3D device. Try this:" & vbCrLf & _
            "    1. From the Control Panel, run the DirectX applet." & vbCrLf & _
            "    2. Click the Direct3D tab and check the Enumerate " & _
            "Reference Rasterizer box. Click Ok." & vbCrLf & _
            "    3. Reboot and try running the program again." & vbCrLf & _
            "If it still doesn't work, try changing to 16-bit color."
        Unload Me
        Exit Sub
    End If
    
'    m_d3dDevice.SetRenderState D3DRS_POINTSPRITE_ENABLE, 1 '//Enable point sprite rendering
'    'Allow Direct3D to size the points
'    m_d3dDevice.SetRenderState D3DRS_POINTSCALE_ENABLE, 1 '//Allow Direct3D to set/alter the size of the Psprites
'    'Set the size
'    m_d3dDevice.SetRenderState D3DRS_POINTSIZE, FtoDW(ParticleSize)
    
    '// The above code uses this function to pass a floating point number (0.01 for example)
    'as a long integer (1 for example)
End Sub
Function FtoDW(f As Single) As Long
    Dim buf As D3DXBuffer
    Dim l As Long
    Set buf = D3DX.CreateBuffer(4)
    D3DX.BufferSetData buf, 0, 4, 1, f
    D3DX.BufferGetData buf, 0, 4, 1, l
    FtoDW = l
End Function

' Release Direct3D objects.
Private Sub Cleanup()
    Set m_d3dDevice = Nothing
    Set m_d3d = Nothing
    Set m_dx8 = Nothing
End Sub
' Draw the scene.
Private Sub RenderObjects()
Dim world_matrix As D3DMATRIX
Dim view_matrix As D3DMATRIX
Dim p As Integer
Dim AnimTweenFactor As Single '//Where we currently are in Tweening

    ' Define the viewing position.
    D3DXMatrixLookAtLH view_matrix, _
        MakeD3DVector(30, 100, 30), _
        MakeD3DVector(0#, 0, 0#), _
        MakeD3DVector(0#, 1#, 0#)
    m_d3dDevice.SetTransform D3DTS_VIEW, view_matrix
    Call UpdateAnimation(AnimTweenFactor)
    Me.lblStatus.Caption = " Anim : " & Format(AnimTweenFactor, "00.000")
'    For p = 0 To 9
'        Call UpdatePlanet(p, AnimTweenFactor)
'    Next
    Call UpdateCam(AnimTweenFactor)
    
    ' Clear the render surface.
    m_d3dDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, &HFF000000, 1#, 0

    ' Begin the scene.
    m_d3dDevice.BeginScene
        ' Select the sphere's material.
        m_d3dDevice.SetMaterial m_SphereMaterial

        m_Theta = m_Theta - 5
        For p = 0 To 10
            If p < 10 Or (p = 10 And Me.chkDrawStars.Value = vbChecked) Then
                'Draw Planet
                Call UpdatePlanet(p, AnimTweenFactor)
                m_d3dDevice.SetTexture 0, planets(p).Texture
                m_d3dDevice.SetTransform D3DTS_WORLD, SetMatrix( _
                    planets(p).Position, _
                    planets(p).yaw, planets(p).pitch, planets(p).roll, _
                    planets(p).xScale, planets(p).yScale, planets(p).zScale)
                m_d3dDevice.DrawPrimitive planets(p).GeomType, planets(p).GeomStart, planets(p).GeomLen
                
                'Draw rings
                If planets(p).Rings > 0 Then
                    m_d3dDevice.SetTexture 0, planets(p).RingTexture
                    m_d3dDevice.SetTransform D3DTS_WORLD, SetMatrix( _
                        planets(p).Position, _
                        planets(p).yaw, planets(p).RingPitch, planets(p).roll, _
                        planets(p).RingScale, planets(p).RingScale, planets(p).RingScale)
                    
                    m_d3dDevice.DrawPrimitive planets(p).RingGeomType, planets(p).RingGeomStart, planets(p).RingGeomLen
                End If
                
                'Draw moons
                If planets(p).Moons > 0 Then
                    Dim m As Integer
                    For m = 1 To planets(p).Moons
                        With planets(p).ArMoon(m)
                            Call UpdateMoon(p, m, AnimTweenFactor)
                                m_d3dDevice.SetTexture 0, .Texture
                                m_d3dDevice.SetTransform D3DTS_WORLD, SetMatrix( _
                                    .Position, _
                                    .yaw, .pitch, .roll, _
                                    .xScale, .yScale, .zScale)
                                
                                m_d3dDevice.DrawPrimitive .GeomType, .GeomStart, .GeomLen
                        End With
                    Next
                End If
                
                'Nth rock from the sun
                If p = 5 Then
                    Me.lblStatus.Caption = Me.lblStatus.Caption & vbCrLf & "moon " & planets(p).ArMoon(1).AngFromPlanet
                End If
            End If
        Next
                
    m_d3dDevice.EndScene

    ' Copy the render surface to the display surface.
    m_d3dDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
End Sub
Private Sub UpdateCam(AnimTweenFactor)
    Dim view_matrix As D3DMATRIX
    Dim camMatrix As D3DMATRIX
    Dim vTo As D3DVECTOR
    Dim CamSpeed As Single
    Dim SpinRate As Single
    
    Dim vTop As D3DVECTOR
    Dim vFront As D3DVECTOR
    
    SpinRate = 0.3
    

    If intVisitPlanet = 0 Then
        CamSpeed = 5
        If KeyUp Then
            CamPitch = CamPitch + SpinRate * AnimTweenFactor
            If CamPitch > PI Then CamPitch = CamPitch - 2 * PI
'            If CamPitch > PI / 2 Then
'                CamPitch = PI / 2 - (CamPitch - PI / 2)
'                If CamYaw > 0 Then
'                    CamYaw = CamYaw - PI
'                Else
'                    CamYaw = CamYaw + PI
'                End If
'                If CamRoll > 0 Then
'                    CamRoll = CamRoll - PI
'                Else
'                    CamRoll = CamRoll + PI
'                End If
'            End If
        End If
        If KeyDown Then
            CamPitch = CamPitch - SpinRate * AnimTweenFactor
            If CamPitch < -PI Then CamPitch = CamPitch + 2 * PI
'            If CamPitch < -PI / 2 Then
'                CamPitch = -PI / 2 + (-PI / 2 + CamPitch)
'                If CamYaw > 0 Then
'                    CamYaw = CamYaw - PI
'                Else
'                    CamYaw = CamYaw + PI
'                End If
'                If CamRoll > 0 Then
'                    CamRoll = CamRoll - PI
'                Else
'                    CamRoll = CamRoll + PI
'                End If
'            End If
        End If
        If KeyLeft Then
            CamYaw = CamYaw - SpinRate * AnimTweenFactor
            If CamYaw < -PI Then CamYaw = CamYaw + 2 * PI
        End If
        If KeyRight Then
            CamYaw = CamYaw + SpinRate * AnimTweenFactor
            If CamYaw > PI Then CamYaw = CamYaw - 2 * PI
        End If
        
        D3DXMatrixRotationYawPitchRoll camMatrix, CamYaw, CamRoll, CamPitch
        vTop = MultVecByMatrix(MakeD3DVector(0, 1, 0), camMatrix)
        vFront = MultVecByMatrix(MakeD3DVector(1, 0, 0), camMatrix)
        
        If bSpace Then
'            CamPos.x = CamPos.x + Cos(CamYaw) * CamSpeed * AnimTweenFactor
'            CamPos.y = CamPos.y + Sin(CamPitch) * CamSpeed * AnimTweenFactor
'            CamPos.z = CamPos.z + Sin(CamYaw) * CamSpeed * AnimTweenFactor
            
            CamPos.x = CamPos.x + vFront.x * CamSpeed * AnimTweenFactor
            CamPos.y = CamPos.y + vFront.y * CamSpeed * AnimTweenFactor
            CamPos.z = CamPos.z + vFront.z * CamSpeed * AnimTweenFactor
            
        End If
        If bReverse Then
'            CamPos.x = CamPos.x - Cos(CamYaw) * CamSpeed * AnimTweenFactor
'            CamPos.y = CamPos.y - Sin(CamPitch) * CamSpeed * AnimTweenFactor
'            CamPos.z = CamPos.z - Sin(CamYaw) * CamSpeed * AnimTweenFactor

            CamPos.x = CamPos.x - vFront.x * CamSpeed * AnimTweenFactor
            CamPos.y = CamPos.y - vFront.y * CamSpeed * AnimTweenFactor
            CamPos.z = CamPos.z - vFront.z * CamSpeed * AnimTweenFactor
            
        End If
'        vTo.x = CamPos.x + Cos(CamYaw)
'        vTo.y = CamPos.y + Sin(CamPitch)
'        vTo.z = CamPos.z + Sin(CamYaw)
        vTo.x = CamPos.x + vFront.x
        vTo.y = CamPos.y + vFront.y
        vTo.z = CamPos.z + vFront.z

    Else
        Dim x, y, z As Single
        Dim SolMod As Single
        Dim dFromSun As Single
        Dim VwAngle As Single
        Dim dist As Single
        Dim AngFromSun As Single
        
        SolMod = 40
        CamSpeed = 2
        With planets(intVisitPlanet)
            VwAngle = (.AngFromSun + .ViewAngle) * Rad
            dFromSun = (SolMod * .dFromSun) + .ViewDist
            x = dFromSun * Sin(VwAngle)
            y = .Position.y
            z = dFromSun * Cos(VwAngle)
            dist = Sqr((x - CamPos.x) ^ 2 + (y - CamPos.y) ^ 2 + (z - CamPos.z) ^ 2)
            If dist < CamSpeed * 4 Then
                CamPos.x = x
                CamPos.y = y
                CamPos.z = z
            Else
                If Abs(CamPos.x - x) < 4 Then
                    CamPos.x = x
                Else
                    CamPos.x = CamPos.x + ((CamPos.x < x) + 0.5) * CamSpeed * -2
                End If
                If Abs(CamPos.y - y) < 4 Then
                    CamPos.y = y
                Else
                    CamPos.y = CamPos.y + ((CamPos.y < y) + 0.5) * CamSpeed * -2
                End If
                If Abs(CamPos.z - z) < 4 Then
                    CamPos.z = z
                Else
                    CamPos.z = CamPos.z + ((CamPos.z < z) + 0.5) * CamSpeed * -2
                End If
            End If
            
            AngFromSun = .AngFromSun - (5 / .dFromSun) * AnimTweenFactor

            vTo.x = SolMod * .dFromSun * Sin(.AngFromSun * Rad)
            vTo.y = .Position.y
            vTo.z = SolMod * .dFromSun * Cos(.AngFromSun * Rad)
        End With
    End If

    ' Define the viewing position.
    If intVisitPlanet = 0 Then
'        view_matrix = SetMatrix(CamPos, CamYaw * 180 / PI, CamPitch * 180 / PI, CamRoll * 180 / PI, 1, 1, 1)
        D3DXMatrixLookAtLH view_matrix, _
            CamPos, _
            vTo, _
            vTop
    Else
        D3DXMatrixLookAtLH view_matrix, _
            CamPos, _
            vTo, _
            MakeD3DVector(0#, Cos(CamPitch), 0#)
    End If
    m_d3dDevice.SetTransform D3DTS_VIEW, view_matrix
    
    Me.lblCamX.Caption = "X " & Format(CamPos.x, "0000.00")
    Me.lblCamY.Caption = "Y " & Format(CamPos.y, "0000.00")
    Me.lblCamZ.Caption = "Z " & Format(CamPos.z, "0000.00")
    Me.lblCamYaw.Caption = "Yaw " & Format(CamYaw * 180 / PI, "000")
    Me.lblCamPitch.Caption = "Pitch " & Format(CamPitch * 180 / PI, "000")
    Me.lblCamRoll.Caption = "Roll " & Format(CamRoll * 180 / PI, "000")

End Sub

Private Function MultVecByMatrix(vec As D3DVECTOR, mat As D3DMATRIX) As D3DVECTOR
    MultVecByMatrix.x = vec.x * mat.m11 + vec.y * mat.m21 + vec.z * mat.m31 + mat.m41
    MultVecByMatrix.y = vec.x * mat.m12 + vec.y * mat.m22 + vec.z * mat.m32 + mat.m42
    MultVecByMatrix.z = vec.x * mat.m13 + vec.y * mat.m23 + vec.z * mat.m33 + mat.m43

End Function

Private Sub UpdatePlanet(p, AnimTweenFactor)
    Dim SolMod As Single
    SolMod = 40
    
    With planets(p)
        If p = 0 Or p = 10 Then
            m_d3dDevice.SetRenderState D3DRS_LIGHTING, False
            .Position.x = 0
            .Position.y = 0
            .Position.z = 0
            Exit Sub
        Else
            If Me.chkLights.Value = vbChecked Then
                m_d3dDevice.SetRenderState D3DRS_LIGHTING, True
            End If
        End If
        .Position.x = SolMod * .dFromSun * Sin(.AngFromSun * Rad)
        .Position.z = SolMod * .dFromSun * Cos(.AngFromSun * Rad)
        .AngFromSun = .AngFromSun - (5 / .dFromSun) * AnimTweenFactor
        If .AngFromSun < 0 Then .AngFromSun = .AngFromSun + 360
        If p = 7 Then
            .pitch = .pitch - 10
            If .pitch < 0 Then .pitch = .pitch + 360
        Else
            .yaw = .yaw - 10
            If .yaw < 0 Then .yaw = .yaw + 360
        End If
    End With
End Sub

Private Sub UpdateMoon(p, m, AnimTweenFactor)
    Dim SolMod As Single
    SolMod = 40
    
    With planets(p).ArMoon(m)

        'Uranus is a special case since it rotates sideways
        If p = 7 Then
            .Position.x = planets(p).Position.x
            .Position.y = planets(p).Position.y + .dFromPlanet * Cos(.AngFromPlanet * Rad)
            .Position.z = planets(p).Position.z + .dFromPlanet * Sin(.AngFromPlanet * Rad)
        Else
            .Position.x = planets(p).Position.x + .dFromPlanet * Sin(.AngFromPlanet * Rad)
            .Position.y = planets(p).Position.y
            .Position.z = planets(p).Position.z + .dFromPlanet * Cos(.AngFromPlanet * Rad)
        End If
            

        .AngFromPlanet = .AngFromPlanet - (60 / .dFromPlanet) * AnimTweenFactor
        If .AngFromPlanet < 0 Then .AngFromPlanet = .AngFromPlanet + 360
    End With

End Sub
Public Function SetMatrix(ObjVector As D3DVECTOR, yaw, pitch, roll, sx, sy, sz) As D3DMATRIX
    Dim rotMatrix As D3DMATRIX
    Dim trnMatrix As D3DMATRIX
    Dim sclMatrix As D3DMATRIX
    Dim RetVal As D3DMATRIX
                        
    D3DXMatrixScaling sclMatrix, sx, sy, sz
    D3DXMatrixRotationYawPitchRoll rotMatrix, yaw * Rad, pitch * Rad, roll * Rad
    D3DXMatrixTranslation trnMatrix, ObjVector.x, ObjVector.y, ObjVector.z
    D3DXMatrixMultiply rotMatrix, sclMatrix, rotMatrix
    D3DXMatrixMultiply RetVal, rotMatrix, trnMatrix
    SetMatrix = RetVal
    
End Function

Private Sub picDisplayArea_Paint()
    RenderObjects
End Sub

Private Sub picDisplayArea_KeyUp(KeyCode As Integer, Shift As Integer)
Select Case KeyCode
    Case vbKeyUp
        KeyUp = False
    Case vbKeyDown
        KeyDown = False
    Case vbKeyLeft
        KeyLeft = False
    Case vbKeyRight
        KeyRight = False
    Case vbKeyPageUp
        Yup = False
    Case vbKeyPageDown
        Ydown = False
    Case vbKeySpace
        bSpace = False
    Case vbKeyB
        bReverse = False
End Select
End Sub

Private Sub picDisplayArea_KeyDown(KeyCode As Integer, Shift As Integer)
Select Case KeyCode
    Case vbKeyUp
        KeyUp = True
    Case vbKeyDown
        KeyDown = True
    Case vbKeyLeft
        KeyLeft = True
    Case vbKeyRight
        KeyRight = True
    Case vbKeyPageUp
        Yup = True
    Case vbKeyPageDown
        Ydown = True
    Case vbKeySpace
        bSpace = True
    Case vbKeyB
        bReverse = True
    Case vbKeyX
        Stop
End Select

End Sub
Private Sub UpdateAnimation(AnimTweenFactor As Single)
Static AnimTweenDir As Boolean '//True = increasing False = Decreasing
Static LastTimeTweened As Long '//So we can do time based animations...

'//Update the position and/or Direction
If AnimTweenDir = True Then
    AnimTweenFactor = AnimTweenFactor + (((GetTickCount() - LastTimeTweened) / 1000) * 1#)
    LastTimeTweened = GetTickCount
    If AnimTweenFactor >= 1# Then
        AnimTweenFactor = 1#
        AnimTweenDir = False
    End If
Else
    AnimTweenFactor = AnimTweenFactor - (((GetTickCount() - LastTimeTweened) / 1000) * 1#)
    LastTimeTweened = GetTickCount
    If AnimTweenFactor <= 0# Then
        AnimTweenFactor = 0#
        AnimTweenDir = True
    End If
End If

Exit Sub
BailOut:
Debug.Print "Error occured whilst updating the animation..."
End Sub
